/* Copyright (C) 2002, by Sandor Fazekas and Janos Torok */
/* Last modified: $Date: 2004/09/01 13:35:07 $ $Revision: 1.5 $ */
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <math.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <gtk/gtkgl.h>
#include <png.h>
#include "movie.h"
#include "global.h"
#include "XPM/icon.xpm"

/* prototypes */
void perr(char *, ...);
void Snapshot(GtkWidget *,gpointer);

void SS_Dialog_Cancel(GtkWidget *widget,gpointer data)
{
  Dial *d;
  d=(Dial *) data;
  gtk_widget_destroy(GTK_WIDGET(d->window));
  *(d->whatisup)=0;
  free(d);
}

void SS_Dialog_Destroy(GtkWidget *widget,GdkEvent *event,gpointer data)
{
  SS_Dialog_Cancel(widget,data);
}

void OutFileOk()
{
  movie.savesnapisup=0;
  gtk_widget_destroy(movie.savesnapwin);
  Snapshot(NULL,(gpointer) 1);
}

void OutFile_CannotOpen()
{
  GtkStyle  *style;		/* style for pixmap background */
  GdkPixmap *pixmap;		/* pixmap for pixmap buttons */
  GdkBitmap *mask;		/* pixmap mask */
  GtkWidget *window;		/* main window */
  GtkWidget *vbox;		/* main vbox */
  GtkWidget *hbox;		/* main hbox */
  GtkWidget *l;			/* labels */
  GtkWidget *ok;		/* button */
  Dial *dial;			/* dialog data */

  movie.savesnapdialup=1;
  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title(GTK_WINDOW(window), "Cannot open output file");
  gtk_widget_realize(window);
  style= gtk_widget_get_style(window);
  pixmap = gdk_pixmap_create_from_xpm_d (window->window, &mask,
		     &style->bg[GTK_STATE_NORMAL],XPMicon);
  gdk_window_set_icon(window->window,NULL,pixmap,mask);
  vbox = gtk_vbox_new(TRUE, 5);
  gtk_container_add (GTK_CONTAINER (window), vbox);
  l=gtk_label_new("  Error: Cannot open output file:  ");
  gtk_box_pack_start(GTK_BOX(vbox),l,TRUE,TRUE,0);
  gtk_widget_show(l);
  l=gtk_label_new(movie.outfile);
  gtk_box_pack_start(GTK_BOX(vbox),l,TRUE,TRUE,0);
  gtk_widget_show(l);
  hbox = gtk_hbox_new(TRUE, 1);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);
  ok=gtk_button_new_with_label("Ok");
  gtk_box_pack_start(GTK_BOX(hbox),ok,TRUE,TRUE,10);
  gtk_widget_show(ok);
  gtk_widget_show(hbox);
  gtk_widget_show(vbox);
  dial=(Dial *)malloc(sizeof(Dial));
  dial->window=window;
  dial->whatisup=&movie.savesnapdialup;
  gtk_signal_connect(GTK_OBJECT (window), "delete_event",
                       (GtkSignalFunc) SS_Dialog_Destroy, (gpointer)dial);
  gtk_signal_connect(GTK_OBJECT (ok), "clicked",
                       (GtkSignalFunc) SS_Dialog_Cancel, (gpointer)dial);
  gtk_widget_show(window);
}

void SS_DoWrite(GtkWidget *widget,gpointer data)
{
  FILE *out;

  gtk_widget_destroy(GTK_WIDGET(data));
  movie.savesnapdialup=0;
  out=fopen(movie.outfile,"w");
  if (out!=NULL) {
    fclose(out);
    OutFileOk();
  } else {
    OutFile_CannotOpen();
  }
}

void OutFile_Exists(ButtSignalfv *DO,int *whatisup)
{
  GtkStyle  *style;		/* style for pixmap background */
  GdkPixmap *pixmap;		/* pixmap for pixmap buttons */
  GdkBitmap *mask;		/* pixmap mask */
  GtkWidget *window;		/* main window */
  GtkWidget *vbox;		/* main vbox */
  GtkWidget *hbox;		/* main hbox */
  GtkWidget *l;			/* labels */
  GtkWidget *ok,*cancel;	/* button */
  Dial *dial;			/* dialog data */

  *whatisup=1;
  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title(GTK_WINDOW(window), "Output file exists");
  gtk_widget_realize(window);
  style= gtk_widget_get_style(window);
  pixmap = gdk_pixmap_create_from_xpm_d (window->window, &mask,
		     &style->bg[GTK_STATE_NORMAL],XPMicon);
  gdk_window_set_icon(window->window,NULL,pixmap,mask);
  vbox = gtk_vbox_new(TRUE, 5);
  gtk_container_add (GTK_CONTAINER (window), vbox);
  l=gtk_label_new("  Output file exists. Overwrite?  ");
  gtk_box_pack_start(GTK_BOX(vbox),l,TRUE,TRUE,0);
  hbox = gtk_hbox_new(TRUE, 1);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);
  ok=gtk_button_new_with_label("Ok");
  cancel=gtk_button_new_with_label("Cancel");
  gtk_box_pack_start(GTK_BOX(hbox),ok,TRUE,TRUE,5);
  gtk_box_pack_start(GTK_BOX(hbox),cancel,TRUE,TRUE,5);
  gtk_widget_show(ok);
  gtk_widget_show(cancel);
  gtk_widget_show(l);
  gtk_widget_show(hbox);
  gtk_widget_show(vbox);
  dial=(Dial *)malloc(sizeof(Dial));
  dial->window=window;
  dial->whatisup=whatisup;
  gtk_signal_connect(GTK_OBJECT (window), "delete_event",
                       (GtkSignalFunc) SS_Dialog_Destroy, (gpointer)dial);
  gtk_signal_connect(GTK_OBJECT (ok), "clicked",
                       (GtkSignalFunc) DO, window);
  gtk_signal_connect(GTK_OBJECT (cancel), "clicked",
                       (GtkSignalFunc) SS_Dialog_Cancel, (gpointer)dial);
  gtk_widget_show(window);
}

void FinishSS(GtkWidget *widget,gpointer data)
{
  const char *t;
  char *s;
  FILE *in;

  if (movie.savesnapdialup) return;
  if ((int)data) {	/* ok */
    movie.savesnapdialup=0;
    t=gtk_file_selection_get_filename(
	  		GTK_FILE_SELECTION(movie.savesnapwin));
    if (t[strlen(t)-1]=='/') {
      s=(char *)calloc(strlen(t)+strlen("movie.png")+5,sizeof(char));
      sprintf(s,"%smovie.png",t);
    } else if (strcmp(&t[strlen(t)-4],".png")!=0) {
      s=(char *)calloc(strlen(t)+7,sizeof(char));
      sprintf(s,"%s.png",t);
    } else {
      s=strdup(t);
    }
    if (movie.outfile!=NULL) free(movie.outfile);
    movie.outfile=s;
    in=fopen(s,"r");
    if (in!=NULL) {
      fclose(in);
      OutFile_Exists(SS_DoWrite,&movie.savesnapdialup);
      return;
    }
    in=fopen(s,"w");
    if (in!=NULL) {
      fclose(in);
      OutFileOk();
      return;
    } else {
      OutFile_CannotOpen();
      return;
    }
  } else {
    movie.savesnapisup=0;
    gtk_widget_destroy(movie.savesnapwin);
  }
}

void Write_PNG(char *file_name, unsigned char *buff,int width,int height)
{
  FILE* file;
  png_structp png_ptr;
  png_infop info_ptr;
  png_bytepp png_image;
  png_image=(png_bytepp) malloc(height*sizeof(png_bytep));

  if (png_image==NULL) {
    perr("PNG malloc error.\n");
  }
  {
    png_bytep png_row = (png_bytep) buff;
    int row_size = 3 * width;
    int i;

    for(i = height - 1; i >= 0; i--)
    {
      png_image[i] = png_row;
      png_row += row_size;
    }
  }
  file = fopen(file_name, "wb");
  if(file == NULL) {
    perr("Unable to open png output file: %s\n",file_name);
  }
  png_ptr = png_create_write_struct(PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
  if (png_ptr == NULL) {
    perr("error in png_create_write_struct\n");
  }
  info_ptr = png_create_info_struct(png_ptr);
  if(info_ptr == NULL) {
    png_destroy_write_struct(&png_ptr,(png_infopp) NULL);
    perr("error in png_create_info_struct\n");
  }
  if(setjmp(png_ptr->jmpbuf)) {
    png_destroy_write_struct(&png_ptr,(png_infopp) NULL);
    perr("error in png_ptr\n");
  }
  png_init_io(png_ptr,file);
  png_set_IHDR(
      png_ptr, info_ptr, width, height, 8, PNG_COLOR_TYPE_RGB,
      PNG_INTERLACE_NONE, PNG_COMPRESSION_TYPE_BASE, PNG_FILTER_TYPE_BASE);
  png_write_info(png_ptr, info_ptr);
  png_write_image(png_ptr, png_image);
  png_write_end(png_ptr, info_ptr);
  png_destroy_write_struct(&png_ptr, (png_infopp) NULL);
  fclose(file);
  free(png_image);
}

void SaveSnap(GtkWidget *widget,gpointer data)
{
  GtkWidget *filesel;

  if (movie.savesnapisup) return;
  movie.savesnapdialup=0;
  movie.savesnapwin=filesel=gtk_file_selection_new("Save snapshot as...");
  gtk_signal_connect (GTK_OBJECT (filesel), "destroy",
	    GTK_SIGNAL_FUNC (FinishSS), (gpointer)0 );
  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION(filesel)->cancel_button),
		"clicked",GTK_SIGNAL_FUNC (FinishSS), (gpointer)0 );
  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION(filesel)->ok_button),
		"clicked",GTK_SIGNAL_FUNC (FinishSS), (gpointer)1 );
  gtk_widget_show(filesel);
  movie.savesnapisup=1;
}

void Snapshot(GtkWidget *widget,gpointer data)
{
  int a,b,l,ok;
  unsigned char *buff;
  char *s;
  FILE *in;
  GdkGLContext *glcontext = gtk_widget_get_gl_context (gl.glarea);
  GdkGLDrawable *gldrawable = gtk_widget_get_gl_drawable (gl.glarea);

  if (!gdk_gl_drawable_gl_begin (gldrawable, glcontext)) return;
  gdk_gl_drawable_swap_buffers (gldrawable);

  a=(int)data;
  if (!a) { /* save with default filename: movie.png */
    if (movie.outfile==NULL) movie.outfile=strdup("movie00000.png");
    if ((strlen(movie.outfile)<5) ||
	(strcmp(&movie.outfile[strlen(movie.outfile)-4],".png")!=0)) {
      free(movie.outfile);
      movie.outfile=strdup("movie00000.png");
    }
    ok=1;
    do {
      in=fopen(movie.outfile,"r");
      if (in==NULL) ok=0;
      else { /* increment name */
	if (isdigit(movie.outfile[strlen(movie.outfile)-5])) {
	  a=strlen(movie.outfile)-5;
	  while ((a>0) && (isdigit(movie.outfile[a]))) a--;
	  a++;
	  b=atoi(&movie.outfile[a])+1;
	  s=strdup(movie.outfile);
	  sprintf(s,"%05d",b);
	  l=strlen(s);
	  free(s);
	  if (l>(int)strlen(movie.outfile)-a-4) {	/* new char */
	    s=(char *) calloc(strlen(movie.outfile)+1,sizeof(char));
	    strcpy(s,movie.outfile);
	    free(movie.outfile);
	    movie.outfile=s;
	    sprintf(&movie.outfile[strlen(movie.outfile)-3-l],"%05d.png",b);
	  } else {
	    sprintf(&movie.outfile[strlen(movie.outfile)-4-l],"%05d.png",b);
	  }
	} else {
	  s=(char *) calloc(strlen(movie.outfile)+1,sizeof(char));
	  strcpy(s,movie.outfile);
	  sprintf(&s[strlen(s)-4],"1.png");
	  free(movie.outfile);
	  movie.outfile=s;
	}
      }
    } while (ok);
  }
  buff=(unsigned char *)malloc(3*(gl.width+1)*(gl.height+1));
  glPixelStorei(GL_PACK_ALIGNMENT,1);
  glReadPixels(0,0,gl.width,gl.height,GL_RGB,GL_UNSIGNED_BYTE,buff);
  Write_PNG(movie.outfile,buff,gl.width,gl.height);

  gdk_gl_drawable_swap_buffers (gldrawable);
  gdk_gl_drawable_gl_end (gldrawable);
}

void Grey()
{
  int a,b,p;
  unsigned char *buff;
  GdkGLContext *glcontext = gtk_widget_get_gl_context (gl.glarea);
  GdkGLDrawable *gldrawable = gtk_widget_get_gl_drawable (gl.glarea);

  if (!gdk_gl_drawable_gl_begin (gldrawable, glcontext)) return;

  buff=(unsigned char *)malloc(3*(gl.width+1)*(gl.height+1));
  glPixelStorei(GL_PACK_ALIGNMENT,1);
  glReadPixels(0,0,gl.width,gl.height,GL_RGB,GL_UNSIGNED_BYTE,buff);
  glDisable(GL_TEXTURE_2D);
  for (a=0;a<3*gl.width;a+=3) {
    for (b=0;b<gl.height;b++) {
      p=b*3*gl.width+a;
      buff[p]=buff[p+1]=buff[p+2]= (unsigned char)
      	((double)buff[p]*0.3+(double)buff[p+1]*0.59+(double)buff[p+2]*0.11);
    }
  }
  glPixelStorei(GL_UNPACK_ALIGNMENT,1);
  glDrawPixels(gl.width,gl.height,GL_RGB,GL_UNSIGNED_BYTE,buff);

  gdk_gl_drawable_swap_buffers (gldrawable);
  gdk_gl_drawable_gl_end (gldrawable);

  free(buff);
}

/* EOF */
